<?php

include('playlink.init.php');

//
// ====================================
function playlink_set_content()
{
	header( "Content-type: text/plain; charset=utf-8" );

	if( isset( $_REQUEST['clear'] ))
	{
		if( file_exists('/tmp/playlink.txt')) unlink('/tmp/playlink.txt');
	}

	$quality = getPlaylinkConfigParameter('quality');
	if( isset( $_REQUEST['quality'] ))
	 if( $quality != $_REQUEST['quality'] )
	 {
		$quality = $_REQUEST['quality'];
		setPlaylinkConfigParameter('quality', $quality );
		playlinkSaveConfig();
	 }


	$stop = getPlaylinkConfigParameter('stop');
	if( isset( $_REQUEST['stop'] ))
	 if( $stop != $_REQUEST['stop'] )
	 {
		$stop = $_REQUEST['stop'];
		setPlaylinkConfigParameter('stop', $stop );
		playlinkSaveConfig();
	}

	if( isset( $_REQUEST['url'] )
	&& $_REQUEST['url'] !== ''  )
	{
		$u = $_REQUEST['url'];

		// get scrapers
		$scrapers = array();

		$d = opendir( 'modules' );
		while ( $m = readdir( $d ) )
		 if ( is_dir( "modules/$m" ))
		  if( file_exists( "modules/$m/def_scraper.php" ) )
		   include( "modules/$m/def_scraper.php" );

		do {
			$again = false;
			foreach( $scrapers as $sc )
			 foreach( $sc->rules as $s => $exp )
			  if( strpos( $u, $s ) > 0 )
			   if( preg_match( $exp, $u, $a ) > 0 )
			   {
				if(( $r = $sc->get( $a[1], $quality )) !== false )
				{
					$u     = $r['url'];
					$again = $r['again'];
				}
				else $u = '';

				toDebug("return={$u}");

				break 2;
			    }

		} while( $again );

		if( isset( $_REQUEST['debug'])) echo "\n\nurl=$u\n";
		else file_put_contents( '/tmp/playlink.txt', $u );

	}

	// send stop
	if( $stop != 0 )
	{
		// get status
		$st = false;
		$a = file('/tmp/appContext');
		if( $a !== false )
		{
			$appStatus = trim( $a[0] );
			$subStatus = trim( $a[1] );

			if( $appStatus == 'music_playback'
			||  $appStatus == 'video_playback'
			||( $appStatus == 'IMSAP'
			&&( $subStatus =='audio' || $subStatus =='video' ))) $st = true;
		}

		if( $st )
		{
			$f = fsockopen('unix:///tmp/CGI_request', -1, $errno, $errstr, 30);
			if ( $f !== false )
			{
				fwrite( $f, 'stop' );

				$s = '';
				while ( ! feof( $f )) $s .= fgets( $f, 128 );
				fclose( $f );
			}
		}
	}

	echo 'ok';
}

// ------------------------------------
function playlinkShowOption( $opt, $val, $title )
{
	if( getPlaylinkConfigParameter( $opt ) == $val ) $sel = ' selected'; else $sel = '';
	echo '<option value="'. $val .'"'. $sel .'>'. getMsg( $title) ."</option>\n";
}

//
// ====================================
function playlink_head()
{

?>
<link rel="stylesheet" href="/modules/core/css/buttons.css" type="text/css" media="screen" charset="utf-8">
<link rel="stylesheet" href="/modules/core/css/sets.css" type="text/css" media="screen" charset="utf-8">
<style type="text/css">

table.area-set {
	width:100%;
	max-width:400px;
}

table.area-text {
	width:100%;

	padding:1px;

	border:1px #ccc solid;
}

.area-text input {
	width:100%;
	height:18px;

	border:0px;
}

.area-text a {
	visibility:hidden;
}

.area-text a img {
	margin:3px 2px 0px;
}

</style>

<script type="text/javascript">

var set_http;

function getXmlHttpRequestObject() {

	if (window.XMLHttpRequest) return new XMLHttpRequest();	// code for IE7+, Firefox, Chrome, Opera, Safari
	else return new ActiveXObject("Microsoft.XMLHTTP");	// code for IE6, IE5
}

function handlePlay() {

	if(set_http.readyState==4) {

		if(set_http.status != 200)
		 alert("Error:"+ set_http.status);
		else {
			var val = users_http.responseText;
			if( val != "ok" ) alert("Respond:"+ val);
		}
	}
}

function sendPlay( form ) {

	var sel = form.elements.quality;
	for (var i = 0; i < sel.options.length; i++) {

		var opt = sel.options[i];
		if(opt.selected) {

			var qual = opt.value;
			break;
		}
	}

	if( form.elements.stop.checked ) st = '1';
	else st = '0';

	url = "?page=playlink_set"
	+ "&quality=" + qual
	+ "&stop=" + st
	+ "&url=" + encodeURIComponent( form.elements.url.value );

	set_http = getXmlHttpRequestObject();
	set_http.onreadystatechange = handlePlay;
	set_http.open("GET", url ,true );
	set_http.setRequestHeader("If-Modified-Since","0");
	set_http.setRequestHeader("Cache-Control","no-cache");
	set_http.send( null );
}

function showHideClear( e ) {

	var p  = document.getElementById('btn_clear');
	if( e.value == '' )
	{
		p.style.visibility = "hidden";
	}
	else
	{
		p.style.visibility = 'visible';
	}
}

function elemClear( e ) {

	var p  = document.getElementById( e );
	p.value = "";
	showHideClear( p );
}

window.onload = function() {

	showHideClear( url );
}
</script>

<?php

}
//
// ------------------------------------
function playlink_body()
{

?>
<div id="container">
<h3><?= getMsg( 'playlinkTitle' ) ?></h3>

<table class="set_list area-set" border="0" cellspacing="0" cellpadding="8">

<form name="one" onsubmit="sendPlay( document.forms.one );return false">

<tr><td><?= getMsg( 'playlinkUrl') ?></td></tr>

<tr><td	width="100%">

<table class="area-text">
<tr><td	width="100%">
<input id="url" class="area-text" name="url" type="text" value="" oninput="showHideClear( this );"/>
</td>
<td>
<a id="btn_clear" href="#" onclick="elemClear('url');"><img src="modules/playlink/clear.png" /></a>
</td></tr></table>

</td></tr>

<tr><td><?= getMsg( 'playlinkQuality') ?>
<select style="display:block; float:right" name="quality" size=1>
<?php
	playlinkShowOption( 'quality', 'hi',  'playlinkQualHi' );
	playlinkShowOption( 'quality', 'mid', 'playlinkQualMid' );
	playlinkShowOption( 'quality', 'lo',  'playlinkQualLow' );

?>
</select></td></tr>

<tr><td><?php

	if( getPlaylinkConfigParameter( 'stop' ) != 0 ) $sel = ' checked'; else $sel = '';
	echo '<input name="stop" type="checkbox"'.$sel.' />';
	echo getMsg( 'playlinkStop');

?></td></tr>

<tr><td align="right">
<button class="buttons" type="submit"><?= getMsg( 'playlinkSend') ?></button>
</td></tr></form>

<?php
	$s = '';
	$a = strtolower( $_SERVER['HTTP_USER_AGENT'] );
	if(     strpos( $a, ' firefox/' ) > 0 ) $s .= '<a href="https://addons.mozilla.org/ru/firefox/addon/play-on-player/">'. getMsg( 'playlinkPluginFirefox') .'</a>';
	elseif( strpos( $a, ' opr/'     ) > 0 ) $s .= '<a href="http://www.moservices.org/modules/playlink/playonplayer.crx">'. getMsg( 'playlinkPluginOpera') .'</a>';
	elseif( strpos( $a, ' chrome/'  ) > 0 ) $s .= '<a href="https://chrome.google.com/webstore/detail/play-on-player/khkoodaeggckcicjfnpfglfkfpodlckf">'. getMsg( 'playlinkPluginChrome' ) .'</a>';

	if( $s != '' )
	{

?>
<tr><td class="set_delim">
<?= $s ?> 
</td></tr>
<?php
	}

?>

</table>
</div>

<?php

}
//
// ====================================
function playlink_form_content()
{

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
<meta name="viewport" content="width=device-width; initial-scale=1.0; maximum-scale=1.0; user-scalable=no;"/>
<meta name="apple-mobile-web-app-capable" content="yes"/>
<meta name="apple-mobile-web-app-status-bar-style" content="black-translucent"/>
<title>moServices - Play link</title>
<link href="http://www.moservices.org/modules/playlink/icons/playlink_60.png" rel="apple-touch-icon" />
<link href="http://www.moservices.org/modules/playlink/icons/playlink_76.png" rel="apple-touch-icon" sizes="76x76" />
<link href="http://www.moservices.org/modules/playlink/icons/playlink_120.png" rel="apple-touch-icon" sizes="120x120" />
<link href="http://www.moservices.org/modules/playlink/icons/playlink_152.png" rel="apple-touch-icon" sizes="152x152" />
<link rel="shortcut icon" href="favicon.ico" />
<link rel="stylesheet" href="modules/core/css/main.css" type="text/css" media="screen" charset="utf-8">
<?php
	playlink_head();

?>
<body style="background-color:#eee;">
<?php
	playlink_body();

?>
</body></html>
<?php

}

?>