<?php
class mailruScraper
{
	public $rules  = array(
		'mail.ru/video' => '#(/mail/.+?)\.html#',
		'mail.ru/' => '#mail\.ru(.+?)\.html#',
	);

	function get( $id, $quality = 'lo' )
	{
	#
	# Based on algorythm by Bigmanalexey and stanley (GlavTV)
	#
		$opts = array(
			'http' => array(
				'method'  => 'GET',
				'user_agent' => 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_9_5) AppleWebKit/537.78.1 (KHTML like Gecko) Version/7.0.6 Safari/537.78.1',
			)
		);
		$context = stream_context_create($opts);

		$url = "http://videoapi.my.mail.ru/videos{$id}.json";
		toDebug('Request:', $url );
		$s = @file_get_contents( $url, false, $context);
		if( $s === false ) return false;

		# extract cookies
		if( preg_match_all( '#Set\-(Cookie\: .+?)\n#s', implode( "\n", $http_response_header ), $a ) > 0 )
		 $header = " extraHeader='". implode( "\r\n", $a[1] ) ."'";
		else $header = '';
		toDebug('Header:', $header );

		# get infos
		$a = json_decode( $s );
		toDebug('Json:', $a );

		if( ! isset( $a->videos )) return false;

		$sts = array();
		foreach( $a->videos as $v )
		{
			$u = $v->url . $header;
			$q = (int)preg_replace( '#[^\d]#', '', $v->key );

			if( $q <= 360 ) $sts['lo'] = $u;
			elseif( $q <= 640 ) $sts['mid'] = $u;
			else $sts['hi'] = $u;
		}

		if( $quality == 'hi' )
		{
			if( isset( $sts['hi']  )) return array( 'url' => $sts['hi'],  'again' => false );
			if( isset( $sts['mid'] )) return array( 'url' => $sts['mid'], 'again' => false );
		}
		elseif( $quality == 'mid' )
		{
			if( isset( $sts['mid'] )) return array( 'url' => $sts['mid'], 'again' => false );
		}
		# low
		if( isset( $sts['lo']  )) return array( 'url' => $sts['lo'],  'again' => false );
		if( isset( $sts['mid'] )) return array( 'url' => $sts['mid'], 'again' => false );
		if( isset( $sts['hi']  )) return array( 'url' => $sts['hi'],  'again' => false );

		return false;
	}
}

$scrapers['mailru'] = new mailruScraper();

?>