<?php
class moonwalkScraper
{
	public $rules  = array(
		'moonwalk.cc/' => '#/video/(.+?)/iframe#',
	);

	function get( $id, $quality = 'lo' )
	{
	#
	# Based on algorythm by GlavTV
	#
		$opts = array(
			'http' => array(
				'method'  => 'GET',
				'user_agent' => 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_9_5) AppleWebKit/537.78.1 (KHTML like Gecko) Version/7.0.6 Safari/537.78.1',
			)
		);
		$context = stream_context_create($opts);

		$url = "http://moonwalk.cc/video/{$id}/iframe";
		$s = @file_get_contents( $url, false, $context);
		if( $s === false ) return false;

		if( preg_match( '#video_token: *\'(.*?)\'#s', $s, $a ) == 0 ) return false;
		$token = 'video_token='. $a[1];

		if( preg_match( '#video_secret: *\'(.*?)\'#s', $s, $a ) > 0 ) $secret = '&video_secret='. $a[1];
		else $secret = '';

		if( preg_match( '#access_key: *\'(.*?)\'#s', $s, $a ) > 0 ) $key = '&access_key='. $a[1];
		else $key = '';

		$opts = array(
			'http' => array(
				'method'  => 'POST',
				'user-agent' => 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_9_5) AppleWebKit/537.78.1 (KHTML like Gecko) Version/7.0.6 Safari/537.78.1',
			)
		);
		$context = stream_context_create($opts);

		$url = "http://moonwalk.cc/sessions/create_session?".$token.$secret.$key.'&content_type=movie';
		$s = @file_get_contents( $url, false, $context);
		if( $s === false ) return false;

		$a = json_decode( $s );

		if( ! isset( $a->manifest_m3u8 )) return false;

		$s = @file_get_contents( $a->manifest_m3u8 );
		if( $s === false ) return false;

		$s = str_replace( "\r", '', $s );
		if( preg_match_all( '|#EXT-X.*?RESOLUTION=\d+x(\d+),.*?\n(.*?)\n|s', $s, $a ) == 0 ) return false;

		$sts = array();
		foreach( $a[1] as $i => $q )
		 if( $q <= 360 ) $sts['lo'] = $a[2][$i];
		 elseif( $q <= 640 ) $sts['mid'] = $a[2][$i];
		 else $sts['hi'] = $a[2][$i];

		if( $quality == 'hi' )
		{
			if( isset( $sts['hi']  )) return array( 'url' => $sts['hi'],  'again' => false );
			if( isset( $sts['mid'] )) return array( 'url' => $sts['mid'], 'again' => false );
		}
		elseif( $quality == 'mid' )
		{
			if( isset( $sts['mid'] )) return array( 'url' => $sts['mid'], 'again' => false );
		}
		# low
		if( isset( $sts['lo']  )) return array( 'url' => $sts['lo'],  'again' => false );
		if( isset( $sts['mid'] )) return array( 'url' => $sts['mid'], 'again' => false );
		if( isset( $sts['hi']  )) return array( 'url' => $sts['hi'],  'again' => false );

		return false;
	}
}

$scrapers['moonwalk'] = new moonwalkScraper();

?>
