<?php
class okruScraper
{
	public $rules  = array(
		'ok.ru/videoembed/' => '#videoembed/(.+)$#',
		'ok.ru/video/'      => '#video/(.+)$#',
		'odnoklassniki.ru/video/' => '#video/(.+)$#',
		'odnoklassniki.ru/videoembed/' => '#videoembed/(.+)$#',
	);

	function get( $id, $quality = 'lo' )
	{
	#
	# Based on algorythm by GlavTV
	#
		$opts = array(
			'http' => array(
				'method'  => 'GET',
				'header'  => "Host: ok.ru\r\n"
#					."User-Agent: Mozilla/5.0 (Android; Mobile; rv:22.0) Gecko/22.0 Firefox/22.0\r\n"
					."Accept: application/json, text/javascript, */*; q=0.01\r\n"
					."X-Requested-With:XMLHttpRequest\r\n"
					."Referer: http://ok.ru/videoembed/$id\r\n"
					."Connection: keep-alive\r\n"
					,
			)
		);
		$context = stream_context_create($opts);

#		$url = "http://m.ok.ru/video/{$id}";
		$url = "http://ok.ru/dk?cmd=videoPlayerMetadata&mid=$id";
		toDebug("url={$url}");

		$s = @file_get_contents( $url, false, $context);
		if( $s === false ) return false;

		$a = json_decode( $s );
		toDebug('Json:', $a );

		if( ! isset( $a->videos )) return false;

		$qs = array('sd'=> 480,'low'=> 360, 'lowest'=> 240, 'mobile'=> 144 );
		$vs = array();
		foreach( $a->videos as $video )
		{
			$q = $video->name;
			if( isset( $qs[ $q ])) $q = $qs[ $q ];
			else $q = '720';

			$vs[ $q ] = $video->url;
		}
		toDebug('videos:', $vs );

		if( $quality == 'hi' )
		{
			if( isset( $vs[720] )) return array( 'url' => $vs[720], 'again' => false );
			if( isset( $vs[480] )) return array( 'url' => $vs[480], 'again' => false );
		}
		elseif( $quality == 'mid' )
		{
			if( isset( $vs[480] )) return array( 'url' => $vs[480], 'again' => false );
		}
		# low
		if( isset( $vs[360] )) return array( 'url' => $vs[360], 'again' => false );
		if( isset( $vs[240] )) return array( 'url' => $vs[240], 'again' => false );
		if( isset( $vs[144] )) return array( 'url' => $vs[144], 'again' => false );
		if( isset( $vs[480] )) return array( 'url' => $vs[480], 'again' => false );

		return false;
	}
}

$scrapers['okru'] = new okruScraper();

?>