<?php
class rutubeScraper
{
	public $rules  = array(
		'rutube.ru/video' => '#/(video/.+?)(\?|/|$)#',
		'rutube.ru/play'  => '#/(embed/.+?)(\?|/|$)#',
	);

	function get( $id, $quality = 'lo' )
	{
	#
	# Based on algorythm by stanley (GlavTV)
	#
		toDebug("id={$id}");

		$opts = array(
			'http' => array(
				'method'  => 'GET',
				'user_agent' => 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_9_5) AppleWebKit/537.78.1 (KHTML like Gecko) Version/7.0.6 Safari/537.78.1',
			)
		);
		$context = stream_context_create($opts);

		if ( strpos( $id, 'embed/') !== false )
		{
			$u = "http://rutube.ru/play/$id";
			$s = @file_get_contents( $u, false, $context);
			if( $s === false ) return false;

			if( preg_match( '|<link rel="canonical.*?href="(.*?)"|s', $s, $a ) == 0 ) return false;
			$id = $a[1];
			toDebug("link={$id}");
		}

		if( preg_match( '#video/(.+?)(\?|/|$)#', $id, $a ) == 0 ) return false;
		$id = $a[1];
		toDebug("id={$id}");

		$u = "http://rutube.ru/api/play/options/$id/?format=json";
		$s = @file_get_contents( $u, false, $context);
		if( $s === false ) return false;

		$a = json_decode( $s );

		if( ! isset( $a->video_balancer )
		||  ! isset( $a->video_balancer->m3u8 )) return false;

		// m3u playlist
		$u = $a->video_balancer->m3u8;
		$s = file_get_contents( $u, false, $context);
		if( $s === false ) return false;

		$s = str_replace( "\r", '', $s );

		if( preg_match_all( '|#EXT-X.*?\n(.*?)\?i=\d+x(\d+)_\d+\n|s', $s, $a ) == 0 ) return false;

		$sts = array();
		foreach( $a[2] as $i => $q )
		 if( $q <= 360 ) $sts['lo'] = $a[1][$i];
		 elseif( $q <= 640 ) $sts['mid'] = $a[1][$i];
		 else $sts['hi'] = $a[1][$i];

		if( $quality == 'hi' )
		{
			if( isset( $sts['hi']  )) return array( 'url' => $sts['hi'],  'again' => false );
			if( isset( $sts['mid'] )) return array( 'url' => $sts['mid'], 'again' => false );
		}
		elseif( $quality == 'mid' )
		{
			if( isset( $sts['mid'] )) return array( 'url' => $sts['mid'], 'again' => false );
		}
		# low
		if( isset( $sts['lo']  )) return array( 'url' => $sts['lo'],  'again' => false );
		if( isset( $sts['mid'] )) return array( 'url' => $sts['mid'], 'again' => false );
		if( isset( $sts['hi']  )) return array( 'url' => $sts['hi'],  'again' => false );

		return false;
	}
}

$scrapers['rutube'] = new rutubeScraper();

?>