<?php
class vimeoScraper
{
	public $rules  = array(
		'vimeo.com/' => '#vimeo\.com/(.+?)(\&|$)#',
	);

	function get( $id, $quality = 'lo' )
	{
		$opts = array(
			'http' => array(
				'method'  => 'GET',
				'user_agent' => 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_9_5) AppleWebKit/537.78.1 (KHTML like Gecko) Version/7.0.6 Safari/537.78.1',
			)
		);
		$context = stream_context_create($opts);

		# Get the main page
		$url = 'https://vimeo.com/'. $id;

		$s = @file_get_contents( $url, false, $context);
		if( $s === false ) return false;

		# Get the config url
		if( preg_match( '|"(https://player\.vimeo\.com/video/'. $id .'/.*?)"|s', $s, $a ) == 0 ) return false;

		$u = $a[1];

#		toDebug("player={$u}");

		$s = file_get_contents( $u, false, $context);
		if( $s === false ) return false;

		$a = json_decode( $s );

#		toDebug("json=", $a);

		$vs = array();

		if( isset( $a->request )
		&&  isset( $a->request->files )
		&&  isset( $a->request->files->progressive ))
		 foreach( $a->request->files->progressive as $v )
		  $vs[ $v->quality ] =$v->url;

		toDebug("videos=", $vs);

		if( $quality == 'hi' )
		{
			if( isset( $vs['1080p'])) return array( 'url' => $vs['1080p'], 'again' => false );
			if( isset( $vs['720p' ])) return array( 'url' => $vs['720p' ], 'again' => false );
			if( isset( $vs['540p' ])) return array( 'url' => $vs['540p' ], 'again' => false );
		}
		elseif( $quality == 'mid' )
		{
			if( isset( $vs['540p' ])) return array( 'url' => $vs['540p' ], 'again' => false );
		}
		# low
		if( isset( $vs['360p' ])) return array( 'url' => $vs['360p' ], 'again' => false );
		if( isset( $vs['540p' ])) return array( 'url' => $vs['540p' ], 'again' => false );
		if( isset( $vs['720p' ])) return array( 'url' => $vs['720p' ], 'again' => false );

		return false;
	}
}

$scrapers['vimeo'] = new vimeoScraper();

?>